# Purpose

eiSoil is a light-weight framework for creating Aggregate Managers (AM) for test beds.
eiSoil is a pluggable system. It gives structure to develop new AMs and provides helpers for common tasks in AM development.

eiSoil is part of the [OFELIA](http://www.fp7-ofelia.eu) [Control Framework (OCF)](https://github.com/fp7-ofelia).
It has been extended to suite a the requirements of [ALIEN](http://www.fp7-alien.eu).

If you don't know what an Aggregate Manager is please see [here](https://alpha.fp7-ofelia.eu/doc/index.php/General_terminology).

## More detailed abstract

This software is a result of the successfully completed OFELIA FP7 project, which paved the way for OpenFlow testbeds in Europe.
With its pluggable and extendable design, eiSoil is now used in several FIRE projects such as [FP7 ALIEN](http://www.fp7-alien.eu/) and [FP7 FELIX](http://www.ict-felix.eu/).
It is used by the backend of the [GENI Portal](https://portal.geni.net/), also [FIBRE](http://www.fibre-ict.eu) and [GEANT](http://www.fp7-ofelia.eu/news-and-events/press-releases/ofelia-and-gEant-cooperation-on-openflow-experimental-facilities/).

In a nutshell, eiSoil solves problems when implementing test-bed orchestration software. eiSoil provides an architectural framework to build Aggregate Managers. AMs are the workhorses of a test-bed - they manage the allocation and provisioning of resources. eiSoil, not only provides the necessary glue between communication handlers and management logic, it also provides helpers for common tasks in AM development. Hence, removes a lot of duplicated work in AM development. The eiSoil software code is available on github.


# Documentation

Before you do anything else, please checkout the [Quickstart](https://raw.github.com/eict/eiSoil/master/doc/eiSoil%20Quickstart.pdf)
Please see the [Wiki](https://github.com/eict/eiSoil/wiki) for more information.
